diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/ERDCore.js b/web/pgadmin/tools/erd/static/js/erd_tool/ERDCore.js
index 23b592149..b63b1786a 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/ERDCore.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/ERDCore.js
@@ -13,11 +13,16 @@
 import createEngine from '@projectstorm/react-diagrams';
 import {DagreEngine, PathFindingLinkFactory, PortModelAlignment} from '@projectstorm/react-diagrams';
 import { ZoomCanvasAction } from '@projectstorm/react-canvas-core';
+import _ from 'lodash';
 
 import {TableNodeFactory, TableNodeModel } from './nodes/TableNode';
 import {OneToManyLinkFactory, OneToManyLinkModel } from './links/OneToManyLink';
 import { OneToManyPortFactory } from './ports/OneToManyPort';
 import ERDModel from './ERDModel';
+import ForeignKeySchema from '../../../../../browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui';
+import diffArray from 'diff-arrays-of-objects';
+import TableSchema from '../../../../../browser/server_groups/servers/databases/schemas/tables/static/js/table.ui';
+import ColumnSchema from '../../../../../browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui';
 
 export default class ERDCore {
   constructor() {
@@ -66,8 +71,8 @@ export default class ERDCore {
           else if(e.function === 'showNote') {
             this.fireEvent({node: e.entity}, 'showNote', true);
           }
-          else if(e.function === 'editNode') {
-            this.fireEvent({node: e.entity}, 'editNode', true);
+          else if(e.function === 'editTable') {
+            this.fireEvent({node: e.entity}, 'editTable', true);
           }
           else if(e.function === 'nodeUpdated') {
             this.fireEvent({}, 'nodesUpdated', true);
@@ -232,6 +237,188 @@ export default class ERDCore {
     return newLink;
   }
 
+  removePortLinks(port) {
+    let links = port.getLinks();
+    Object.values(links).forEach((link)=>{
+      link.getTargetPort().remove();
+      link.getSourcePort().remove();
+      link.setSelected(false);
+      link.remove();
+    });
+  }
+
+  syncTableLinks(tableNode, oldTableData) {
+    let tableData = tableNode.getData();
+    let tableNodesDict = this.getModel().getNodesDict();
+
+    const addLink = (theFk)=>{
+      let newData = {
+        local_table_uid: tableNode.getID(),
+        local_column_attnum: undefined,
+        referenced_table_uid: theFk.references,
+        referenced_column_attnum: undefined,
+      };
+      let sourceNode = tableNodesDict[newData.referenced_table_uid];
+
+      newData.local_column_attnum = _.find(tableNode.getColumns(), (col)=>col.name==theFk.local_column).attnum;
+      newData.referenced_column_attnum = _.find(sourceNode.getColumns(), (col)=>col.name==theFk.referenced).attnum;
+
+      this.addLink(newData, 'onetomany');
+    };
+
+    const removeLink = (theFk)=>{
+      let attnum = _.find(tableNode.getColumns(), (col)=>col.name==theFk.local_column).attnum;
+      let existPort = tableNode.getPort(tableNode.getPortName(attnum));
+      if(existPort && existPort.getSubtype() == 'many') {
+        existPort.removeAllLinks();
+        tableNode.removePort(existPort);
+      }
+    };
+
+    const changeDiff = diffArray(
+      oldTableData?.foreign_key || [],
+      tableData?.foreign_key || [],
+      'cid'
+    );
+
+    changeDiff.added.forEach((theFk)=>{
+      addLink(theFk.columns[0]);
+    });
+    changeDiff.removed.forEach((theFk)=>{
+      removeLink(theFk.columns[0]);
+    });
+
+    if(changeDiff.updated.length > 0) {
+      for(const changedRow of changeDiff.updated) {
+        let rowIndx = _.findIndex(tableData.foreign_key, (f)=>f.cid==changedRow.cid);
+        const changeDiffCols = diffArray(
+          oldTableData.foreign_key[rowIndx].columns,
+          tableData.foreign_key[rowIndx].columns,
+          'cid'
+        );
+        if(changeDiffCols.removed.length > 0 || changeDiffCols.added.length > 0) {
+          removeLink(changeDiffCols.removed[0]);
+          addLink(changeDiffCols.added[0]);
+        }
+      }
+    }
+  }
+
+  addOneToManyLink(onetomanyData) {
+    let newFk = new ForeignKeySchema({}, {}, ()=>{}, {autoindex: false});
+    let tableNodesDict = this.getModel().getNodesDict();
+    let fkColumn = {};
+    let sourceNode = tableNodesDict[onetomanyData.referenced_table_uid];
+    let targetNode = tableNodesDict[onetomanyData.local_table_uid];
+
+    fkColumn.local_column = _.find(targetNode.getColumns(), (col)=>col.attnum==onetomanyData.local_column_attnum).name;
+    fkColumn.referenced = _.find(sourceNode.getColumns(), (col)=>col.attnum==onetomanyData.referenced_column_attnum).name;
+    fkColumn.references = onetomanyData.referenced_table_uid;
+    fkColumn.references_table_name = sourceNode.getData().name;
+
+    let tableData = targetNode.getData();
+    tableData.foreign_key = tableData.foreign_key || [];
+
+    let col = newFk.fkColumnSchema.getNewData(fkColumn);
+    tableData.foreign_key.push(
+      newFk.getNewData({
+        columns: [col],
+      })
+    );
+    targetNode.setData(tableData);
+    let newLink = this.addLink(onetomanyData, 'onetomany');
+    this.clearSelection();
+    newLink.setSelected(true);
+    this.repaint();
+  }
+
+  removeOneToManyLink(link) {
+    let linkData = link.getData();
+    let tableNode = this.getModel().getNodesDict()[linkData.local_table_uid];
+    let tableData = tableNode.getData();
+
+    let newForeingKeys = [];
+    tableData.foreign_key?.forEach((theFkRow)=>{
+      let theFk = theFkRow.columns[0];
+      let attnum = _.find(tableNode.getColumns(), (col)=>col.name==theFk.local_column).attnum;
+      /* Skip all those whose attnum matches to the link */
+      if(linkData.local_column_attnum != attnum) {
+        newForeingKeys.push(theFkRow);
+      }
+    });
+    tableData.foreign_key = newForeingKeys;
+    tableNode.setData(tableData);
+    link.getTargetPort().remove();
+    link.getSourcePort().remove();
+    link.setSelected(false);
+    link.remove();
+  }
+
+  addManyToManyLink(manytomanyData) {
+    let nodes = this.getModel().getNodesDict();
+    let leftNode = nodes[manytomanyData.left_table_uid];
+    let rightNode = nodes[manytomanyData.right_table_uid];
+
+    let tableObj = new TableSchema({}, {}, {
+      constraints:()=>{},
+      columns:()=>new ColumnSchema(()=>{}, {}, {}, {}),
+      vacuum_settings:()=>{},
+    }, ()=>{}, ()=>{}, ()=>{}, ()=>{});
+
+    let tableData = tableObj.getNewData({
+      name: `${leftNode.getData().name}_${rightNode.getData().name}`,
+      schema: leftNode.getData().schema,
+      columns: [tableObj.columnsSchema.getNewData({
+        ...leftNode.getColumnAt(manytomanyData.left_table_column_attnum),
+        'name': `${leftNode.getData().name}_${leftNode.getColumnAt(manytomanyData.left_table_column_attnum).name}`,
+        'attnum': 0,
+        'is_primary_key': false,
+      }),tableObj.columnsSchema.getNewData({
+        ...rightNode.getColumnAt(manytomanyData.right_table_column_attnum),
+        'name': `${rightNode.getData().name}_${rightNode.getColumnAt(manytomanyData.right_table_column_attnum).name}`,
+        'attnum': 1,
+        'is_primary_key': false,
+      })],
+    });
+
+    // let tableData = {
+    //   name: `${leftNode.getData().name}_${rightNode.getData().name}`,
+    //   schema: leftNode.getData().schema,
+    //   columns: [{
+    //     ...leftNode.getColumnAt(manytomanyData.left_table_column_attnum),
+    //     'name': `${leftNode.getData().name}_${leftNode.getColumnAt(manytomanyData.left_table_column_attnum).name}`,
+    //     'is_primary_key': false,
+    //     'attnum': 0,
+    //   },{
+    //     ...rightNode.getColumnAt(manytomanyData.right_table_column_attnum),
+    //     'name': `${rightNode.getData().name}_${rightNode.getColumnAt(manytomanyData.right_table_column_attnum).name}`,
+    //     'is_primary_key': false,
+    //     'attnum': 1,
+    //   }],
+    // };
+    let newNode = this.addNode(tableData);
+    this.clearSelection();
+    newNode.setSelected(true);
+
+    let linkData = {
+      local_table_uid: newNode.getID(),
+      local_column_attnum: newNode.getColumns()[0].attnum,
+      referenced_table_uid: manytomanyData.left_table_uid,
+      referenced_column_attnum : manytomanyData.left_table_column_attnum,
+    };
+    this.addOneToManyLink(linkData);
+
+    linkData = {
+      local_table_uid: newNode.getID(),
+      local_column_attnum: newNode.getColumns()[1].attnum,
+      referenced_table_uid: manytomanyData.right_table_uid,
+      referenced_column_attnum : manytomanyData.right_table_column_attnum,
+    };
+    this.addOneToManyLink(linkData);
+
+    this.repaint();
+  }
+
   serialize(version) {
     return {
       version: version||0,
@@ -246,65 +433,53 @@ export default class ERDCore {
   }
 
   serializeData() {
-    let nodes = {}, links = {};
+    let nodes = {};
     let nodesDict = this.getModel().getNodesDict();
 
     Object.keys(nodesDict).forEach((id)=>{
       nodes[id] = nodesDict[id].serializeData();
     });
 
-    this.getModel().getLinks().map((link)=>{
-      links[link.getID()] = link.serializeData(nodesDict);
-    });
-
-    /* Separate the links from nodes so that we don't have any dependancy issues */
     return {
       'nodes': nodes,
-      'links': links,
     };
   }
 
   deserializeData(data){
     let oidUidMap = {};
-    let uidFks = [];
-    data.forEach((node)=>{
-      let newData = {
-        name: node.name,
-        schema: node.schema,
-        description: node.description,
-        columns: node.columns,
-        primary_key: node.primary_key,
-      };
-      let newNode = this.addNode(newData);
-      oidUidMap[node.oid] = newNode.getID();
-      if(node.foreign_key) {
-        node.foreign_key.forEach((a_fk)=>{
-          uidFks.push({
-            uid: newNode.getID(),
-            data: a_fk.columns[0],
-          });
-        });
-      }
+
+    /* Add the nodes */
+    data.forEach((nodeData)=>{
+      let newNode = this.addNode(TableSchema.getErdSupportedData(nodeData));
+      oidUidMap[nodeData.oid] = newNode.getID();
     });
 
     /* Lets use the oidUidMap for creating the links */
-    uidFks.forEach((fkData)=>{
-      let tableNodesDict = this.getModel().getNodesDict();
-      let newData = {
-        local_table_uid: fkData.uid,
-        local_column_attnum: undefined,
-        referenced_table_uid: oidUidMap[fkData.data.references],
-        referenced_column_attnum: undefined,
-      };
-
-      let sourceNode = tableNodesDict[newData.referenced_table_uid];
-      let targetNode = tableNodesDict[newData.local_table_uid];
-
-      newData.local_column_attnum = _.find(targetNode.getColumns(), (col)=>col.name==fkData.data.local_column).attnum;
-      newData.referenced_column_attnum = _.find(sourceNode.getColumns(), (col)=>col.name==fkData.data.referenced).attnum;
-
-      this.addLink(newData, 'onetomany');
+    let tableNodesDict = this.getModel().getNodesDict();
+    _.forIn(tableNodesDict, (node, uid)=>{
+      let nodeData = node.getData();
+      if(nodeData.foreign_key) {
+        nodeData.foreign_key.forEach((theFk)=>{
+          delete theFk.oid;
+          theFk = theFk.columns[0];
+          theFk.references = oidUidMap[theFk.references];
+          let newData = {
+            local_table_uid: uid,
+            local_column_attnum: undefined,
+            referenced_table_uid: theFk.references,
+            referenced_column_attnum: undefined,
+          };
+          let sourceNode = tableNodesDict[newData.referenced_table_uid];
+          let targetNode = tableNodesDict[newData.local_table_uid];
+
+          newData.local_column_attnum = _.find(targetNode.getColumns(), (col)=>col.name==theFk.local_column).attnum;
+          newData.referenced_column_attnum = _.find(sourceNode.getColumns(), (col)=>col.name==theFk.referenced).attnum;
+
+          this.addLink(newData, 'onetomany');
+        });
+      }
     });
+
     setTimeout(this.dagreDistributeNodes.bind(this), 250);
   }
 
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/DialogWrapper.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/DialogWrapper.js
index cb0b1ff52..0ed761629 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/DialogWrapper.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/DialogWrapper.js
@@ -7,152 +7,98 @@
 //
 //////////////////////////////////////////////////////////////
 
-import gettext from 'sources/gettext';
-import * as commonUtils from 'sources/utils';
+import React from 'react';
+import ReactDOM from 'react-dom';
+import SchemaView from '../../../../../../static/js/SchemaView';
 
 export default class DialogWrapper {
-  constructor(dialogContainerSelector, dialogTitle, typeOfDialog,
-    jquery, pgBrowser, alertify, backform, backgrid) {
-
+  constructor(dialogContainerSelector, dialogTitle, typeOfDialog, alertify, serverInfo) {
     this.dialogContainerSelector = dialogContainerSelector;
     this.dialogTitle = dialogTitle;
-    this.jquery = jquery;
-    this.pgBrowser = pgBrowser;
     this.alertify = alertify;
-    this.backform = backform;
-    this.backgrid = backgrid;
     this.typeOfDialog = typeOfDialog;
+    this.serverInfo = serverInfo;
+
+    let self = this;
+    this.hooks = {
+      onshow: ()=>{
+        self.createDialog(self.elements.content);
+      },
+      onclose: ()=>{
+        self.cleanupDialog(self.elements.content);
+      }
+    };
   }
 
-  main(title, dialogModel, okCallback) {
+  main(title, dialogSchema, okCallback) {
     this.set('title', title);
-    this.dialogModel = dialogModel;
+    this.dialogSchema = dialogSchema;
     this.okCallback = okCallback;
   }
 
   build() {
-    this.alertify.pgDialogBuild.apply(this);
-  }
-
-  disableOKButton() {
-    this.__internal.buttons[1].element.disabled = true;
+    this.elements.dialog.classList.add('erd-dialog');
   }
 
-  enableOKButton() {
-    this.__internal.buttons[1].element.disabled = false;
-  }
-
-  focusOnDialog(alertifyDialog) {
-    let backform_tab = this.jquery(alertifyDialog.elements.body).find('.backform-tab');
-    backform_tab.attr('tabindex', -1);
-    this.pgBrowser.keyboardNavigation.getDialogTabNavigator(this.jquery(alertifyDialog.elements.dialog));
-    let container = backform_tab.find('.tab-content:first > .tab-pane.active:first');
-
-    if(container.length === 0 && alertifyDialog.elements.content.innerHTML) {
-      container = this.jquery(alertifyDialog.elements.content);
-    }
-    commonUtils.findAndSetFocus(container);
+  prepare() {
+    /* If tooltip is mounted after alertify in dom and button is click,
+    alertify re-positions itself on DOM to come in focus. This makes it lose
+    the button click events. Making it modal along with following fixes things. */
+    this.elements.modal.style.maxHeight=0;
+    this.elements.modal.style.maxWidth='none';
+    this.elements.modal.style.overflow='visible';
+    this.elements.dimmer.style.display='none';
   }
 
   setup() {
     return {
-      buttons: [{
-        text: gettext('Cancel'),
-        key: 27,
-        className: 'btn btn-secondary fa fa-lg fa-times pg-alertify-button',
-        'data-btn-name': 'cancel',
-      }, {
-        text: gettext('OK'),
-        key: 13,
-        className: 'btn btn-primary fa fa-lg fa-save pg-alertify-button',
-        'data-btn-name': 'ok',
-      }],
+      buttons: [],
       // Set options for dialog
       options: {
         title: this.dialogTitle,
         //disable both padding and overflow control.
         padding: !1,
         overflow: !1,
-        model: 0,
         resizable: true,
         maximizable: true,
         pinnable: false,
         closableByDimmer: false,
-        modal: false,
+        modal: true,
+        autoReset: false,
       },
     };
   }
 
-  prepare() {
-    const $container = this.jquery(this.dialogContainerSelector);
-    const dialog = this.createDialog($container);
-    dialog.render();
-    this.elements.content.innerHTML = '';
-    this.elements.content.appendChild($container.get(0));
-    this.jquery(this.elements.body.childNodes[0]).addClass(
-      'alertify_tools_dialog_properties obj_properties'
-    );
-    const statusBar = this.jquery(
-      '<div class=\'pg-prop-status-bar pg-prop-status-bar-absolute pg-el-xs-12 d-none\'>' +
-      '  <div class="error-in-footer"> ' +
-      '    <div class="d-flex px-2 py-1"> ' +
-      '      <div class="pr-2"> ' +
-      '        <i class="fa fa-exclamation-triangle text-danger" aria-hidden="true"></i> ' +
-      '      </div> ' +
-      '      <div class="alert-text" role="alert"></div> ' +
-      '       <div class="ml-auto close-error-bar"> ' +
-      '          <a aria-label="' + gettext('Close error bar') + '" class="close-error fa fa-times text-danger"></a> ' +
-      '        </div> ' +
-      '    </div> ' +
-      '  </div> ' +
-      '</div>').appendTo($container);
-
-    statusBar.find('.close-error').on('click', ()=>{
-      statusBar.addClass('d-none');
+  onSaveClick(isNew, data) {
+    return new Promise((resolve)=>{
+      this.okCallback(data);
+      this.close();
+      resolve();
     });
-
-    var onSessionInvalid = (msg) => {
-      statusBar.find('.alert-text').text(msg);
-      statusBar.removeClass('d-none');
-      this.disableOKButton();
-      return true;
-    };
-
-    var onSessionValidated = () => {
-      statusBar.find('.alert-text').text('');
-      statusBar.addClass('d-none');
-      this.enableOKButton();
-      return true;
-    };
-
-    this.dialogModel.on('pgadmin-session:valid', onSessionValidated);
-    this.dialogModel.on('pgadmin-session:invalid', onSessionInvalid);
-    this.dialogModel.startNewSession();
-    this.disableOKButton();
-    this.focusOnDialog(this);
   }
 
-  callback(event) {
-    if (this.wasOkButtonPressed(event)) {
-      this.okCallback(this.view.model.toJSON(true));
-    }
-  }
-
-  createDialog($container) {
-    let fields = this.backform.generateViewSchema(
-      null, this.dialogModel, 'create', null, null, true, null
-    );
-
-    this.view = new this.backform.Dialog({
-      el: $container,
-      model: this.dialogModel,
-      schema: fields,
-    });
-
-    return this.view;
+  createDialog(container) {
+    let self = this;
+    ReactDOM.render(
+      <SchemaView
+        formType={'dialog'}
+        getInitData={()=>Promise.resolve({})}
+        schema={this.dialogSchema}
+        viewHelperProps={{
+          mode: 'create',
+          keepCid: true,
+          serverInfo: this.serverInfo,
+        }}
+        onSave={this.onSaveClick.bind(this)}
+        onClose={()=>self.close()}
+        onDataChange={()=>{}}
+        hasSQL={false}
+        disableSqlHelp={true}
+        disableDialogHelp={true}
+      />, container);
   }
 
-  wasOkButtonPressed(event) {
-    return event.button['data-btn-name'] === 'ok';
+  cleanupDialog(container) {
+    ReactDOM.unmountComponentAtNode(container);
   }
 }
diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
index 5a35243ab..dc2421b7e 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/ManyToManyDialog.js
@@ -8,13 +8,48 @@
 //////////////////////////////////////////////////////////////
 
 import gettext from 'sources/gettext';
-import Backform from 'sources/backform.pgadmin';
 import Alertify from 'pgadmin.alertifyjs';
-import $ from 'jquery';
+import BaseUISchema from 'sources/SchemaView/base_schema.ui';
 
 import DialogWrapper from './DialogWrapper';
 import _ from 'lodash';
 
+class ManyToManySchema extends BaseUISchema {
+  constructor(fieldOptions={}, initValues={}) {
+    super({
+      left_table_uid: undefined,
+      left_table_column_attnum: undefined,
+      right_table_uid: undefined,
+      right_table_column_attnum: undefined,
+      ...initValues,
+    });
+    this.fieldOptions = fieldOptions;
+  }
+  get baseFields() {
+    return [{
+      id: 'left_table_uid', label: gettext('Local Table'),
+      type: 'select', readonly: true, controlProps: {allowClear: false},
+      options: this.fieldOptions.left_table_uid,
+    }, {
+      id: 'left_table_column_attnum', label: gettext('Local Column'),
+      type: 'select', options: this.fieldOptions.left_table_column_attnum,
+      controlProps: {allowClear: false}, noEmpty: true,
+    },{
+      id: 'right_table_uid', label: gettext('Referenced Table'),
+      type: 'select', options: this.fieldOptions.right_table_uid,
+      controlProps: {allowClear: false}, noEmpty: true,
+    },{
+      id: 'right_table_column_attnum', label: gettext('Referenced Column'),
+      controlProps: {allowClear: false}, deps: ['right_table_uid'],
+      type: (state)=>({
+        type: 'select',
+        options: state.right_table_uid ? ()=>this.fieldOptions.getRefColumns(state.right_table_uid) : [],
+        optionsReloadBasis: state.right_table_uid,
+      }),
+    }];
+  }
+}
+
 export default class ManyToManyDialog {
   constructor(pgBrowser) {
     this.pgBrowser = pgBrowser;
@@ -24,93 +59,29 @@ export default class ManyToManyDialog {
     return 'manytomany_dialog';
   }
 
-  getDataModel(attributes, tableNodesDict) {
-    const parseColumns = (columns)=>{
-      return columns.map((col)=>{
+  getUISchema(attributes, tableNodesDict) {
+    let tablesData = [];
+    _.forEach(tableNodesDict, (node, uid)=>{
+      let [schema, name] = node.getSchemaTableName();
+      tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
+    });
+
+    return new ManyToManySchema({
+      left_table_uid: tablesData,
+      left_table_column_attnum: tableNodesDict[attributes.left_table_uid].getColumns().map((col)=>{
         return {
-          value: col.attnum, label: col.name,
+          value: col.attnum, label: col.name, 'image': 'icon-column',
         };
-      });
-    };
-
-    let dialogModel = this.pgBrowser.DataModel.extend({
-      defaults: {
-        left_table_uid: undefined,
-        left_table_column_attnum: undefined,
-        right_table_uid: undefined,
-        right_table_column_attnum: undefined,
+      }),
+      right_table_uid: tablesData,
+      getRefColumns: (uid)=>{
+        return tableNodesDict[uid].getColumns().map((col)=>{
+          return {
+            value: col.attnum, label: col.name, 'image': 'icon-column',
+          };
+        });
       },
-      schema: [{
-        id: 'left_table_uid', label: gettext('Left Table'),
-        type: 'select2', readonly: true,
-        options: ()=>{
-          let retOpts = [];
-          _.forEach(tableNodesDict, (node, uid)=>{
-            let [schema, name] = node.getSchemaTableName();
-            retOpts.push({value: uid, label: `(${schema}) ${name}`});
-          });
-          return retOpts;
-        },
-      }, {
-        id: 'left_table_column_attnum', label: gettext('Left table Column'),
-        type: 'select2', disabled: false, first_empty: false,
-        editable: true, options: (view)=>{
-          return parseColumns(tableNodesDict[view.model.get('left_table_uid')].getColumns());
-        },
-      },{
-        id: 'right_table_uid', label: gettext('Right Table'),
-        type: 'select2', disabled: false,
-        editable: true, options: (view)=>{
-          let retOpts = [];
-          _.forEach(tableNodesDict, (node, uid)=>{
-            if(uid === view.model.get('left_table_uid')) {
-              return;
-            }
-            let [schema, name] = node.getSchemaTableName();
-            retOpts.push({value: uid, label: `(${schema}) ${name}`});
-          });
-          return retOpts;
-        },
-      },{
-        id: 'right_table_column_attnum', label: gettext('Right table Column'),
-        type: 'select2', disabled: false, deps: ['right_table_uid'],
-        editable: true, options: (view)=>{
-          if(view.model.get('right_table_uid')) {
-            return parseColumns(tableNodesDict[view.model.get('right_table_uid')].getColumns());
-          }
-          return [];
-        },
-      }],
-      validate: function(keys) {
-        var msg = undefined;
-
-        // Nothing to validate
-        if (keys && keys.length == 0) {
-          this.errorModel.clear();
-          return null;
-        } else {
-          this.errorModel.clear();
-        }
-
-        if (_.isUndefined(this.get('left_table_column_attnum')) || this.get('left_table_column_attnum') == '') {
-          msg = gettext('Select the left table column.');
-          this.errorModel.set('left_table_column_attnum', msg);
-          return msg;
-        }
-        if (_.isUndefined(this.get('right_table_uid')) || this.get('right_table_uid') == '') {
-          msg = gettext('Select the right table.');
-          this.errorModel.set('right_table_uid', msg);
-          return msg;
-        }
-        if (_.isUndefined(this.get('right_table_column_attnum')) || this.get('right_table_column_attnum') == '') {
-          msg = gettext('Select the right table column.');
-          this.errorModel.set('right_table_column_attnum', msg);
-          return msg;
-        }
-      },
-    });
-
-    return new dialogModel(attributes);
+    }, attributes);
   }
 
   createOrGetDialog(title) {
@@ -122,19 +93,16 @@ export default class ManyToManyDialog {
           `<div class="${dialogName}"></div>`,
           title,
           null,
-          $,
-          this.pgBrowser,
           Alertify,
-          Backform
         );
       });
     }
     return Alertify[dialogName];
   }
 
-  show(title, attributes, tablesData, sVersion, callback) {
+  show(title, attributes, tablesData, serverInfo, callback) {
     let dialogTitle = title || gettext('Unknown');
-    const dialog = this.createOrGetDialog('manytomany_dialog');
-    dialog(dialogTitle, this.getDataModel(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
+    const dialog = this.createOrGetDialog('manytomany_dialog', serverInfo);
+    dialog(dialogTitle, this.getUISchema(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
   }
 }
